﻿using System;
using System.Windows.Forms;
using Microsoft.PointOfService;

namespace SampleApplication
{
    public partial class Form1 : Form
    {
        PosPrinter m_PosPrinter = null;
        CashDrawer m_CashDrawer = null;
        PosExplorer posExplorerPr;
        PosExplorer posExplorerDr;
        static DeviceCollection deviceInfoPrinter;
        static DeviceCollection deviceInfoDrawer;

        string m_strLogicalNamePr = null;
        string m_strLogicalNameDr = null;

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            int a = 0;
            int b = 0;
            
            try
            {
                posExplorerPr = new PosExplorer(this);
                deviceInfoPrinter = posExplorerPr.GetDevices(DeviceType.PosPrinter);

                foreach (DeviceInfo device in deviceInfoPrinter)
                {
                    try
                    {
                        // Generates a PosExplorer.
                        posExplorerPr = new PosExplorer(this);
                        DeviceInfo deviceInfo = null;

                        // Retrieve device information by device category and logical device name.
                        if (device.LogicalNames.Length != 0)
                        {
                            if (device.LogicalNames != null)
                            {
                                for (int z = 0; z < device.LogicalNames.Length; z++)
                                {
                                    m_strLogicalNamePr = device.LogicalNames[z];
                                    deviceInfo = posExplorerPr.GetDevice(DeviceType.PosPrinter, m_strLogicalNamePr);

                                    if (deviceInfo != null)
                                    {
                                        comboBox_Pr.Items.Add(m_strLogicalNamePr);
                                        a++;
                                    }
                                }
                            }
                        }
                    }
                    catch (Exception)
                    {
                        // Throw
                    }
                }
            }
            catch (Exception)
            {
                // Throw
            }

            if (a != 0)
            {
                comboBox_Pr.SelectedIndex = 0;
                button_PDeviceOpen.Enabled = true;
                button_PDeviceClose.Enabled = false;
                button_Receipt.Enabled = false;
                button_RotatePrint.Enabled = false;
            }
            else
            {
                button_PDeviceOpen.Enabled = false;
                button_PDeviceClose.Enabled = false;
                button_Receipt.Enabled = false;
                button_RotatePrint.Enabled = false;
            }

            try
            {
                posExplorerDr = new PosExplorer(this);
                deviceInfoDrawer = posExplorerDr.GetDevices(DeviceType.CashDrawer);

                foreach (DeviceInfo device in deviceInfoDrawer)
                {
                    try
                    {
                        // Generates a PosExplorer.
                        posExplorerDr = new PosExplorer(this);
                        DeviceInfo deviceInfo = null;

                        // Retrieve device information by device category and logical device name.
                        if (device.LogicalNames.Length != 0)
                        {
                            if (device.LogicalNames != null)
                            {
                                for (int z = 0; z < device.LogicalNames.Length; z++)
                                {
                                    m_strLogicalNameDr = device.LogicalNames[z];
                                    deviceInfo = posExplorerDr.GetDevice(DeviceType.CashDrawer, m_strLogicalNameDr);

                                    if (deviceInfo != null)
                                    {
                                        comboBox_Dr.Items.Add(m_strLogicalNameDr);
                                        b++;
                                    }
                                }
                            }
                        }
                    }
                    catch (Exception)
                    {
                        // Throw
                    }
                }
            }
            catch (Exception)
            {
                // Throw
            }

            if (b != 0)
            {
                comboBox_Dr.SelectedIndex = 0;
                button_DDeviceOpen.Enabled = true;
                button_DDeviceClose.Enabled = false;
                button_OpenDrawer.Enabled = false;
            }
            else
            {
                button_DDeviceOpen.Enabled = false;
                button_DDeviceClose.Enabled = false;
                button_OpenDrawer.Enabled = false;
            }

        }

        // Printer Device Open
        private void button_PDeviceOpen_Click(object sender, EventArgs e)
        {
            int r = 0;
            try
            {
                if (m_PosPrinter == null)
                {
                    // Generates a PosExplorer.
                    posExplorerPr = new PosExplorer(this);
                    DeviceInfo deviceInfo = null;

                    // Retrieve device information by device category and logical device name.
                    m_strLogicalNamePr = comboBox_Pr.SelectedItem.ToString();
                    deviceInfo = posExplorerPr.GetDevice(DeviceType.PosPrinter, m_strLogicalNamePr);
                    m_PosPrinter = (PosPrinter)posExplorerPr.CreateInstance(deviceInfo);

                    // Registering an Event Handler
                    SetupPrinterEvents();
                }

                button_PDeviceClose.Enabled = true;

                // DeviceOpen
                m_PosPrinter.Open();
                textBox1.Text += "PP : Open = Success\r\n";
                r++;
                m_PosPrinter.Claim(1000);
                textBox1.Text += "PP : Claim(1000) = Success\r\n";
                r++;
                m_PosPrinter.PowerNotify = PowerNotification.Enabled;
                textBox1.Text += "PP : PowerNotify(Enabled) = Success\r\n";
                r++;
                m_PosPrinter.DeviceEnabled = true;
                textBox1.Text += "PP : DeviceEnabled(true) = Success\r\n";

                button_Receipt.Enabled = true;
                button_RotatePrint.Enabled = true;

            }
            catch (PosControlException ex)
            {
                // Throw
                switch (r)
                {
                    case 0:
                        textBox1.Text += "PP : Open = " + CheckErrorCode(ex) +"\r\n";
                        break;
                    case 1:
                        textBox1.Text += "PP : Claim(1000) = " + CheckErrorCode(ex) + "\r\n";
                        break;
                    case 2:
                        textBox1.Text += "PP : PowerNotify(Enabled) = " + CheckErrorCode(ex) + "\r\n";
                        break;
                    case 3:
                        textBox1.Text += "PP : DeviceEnabled(true) = " + CheckErrorCode(ex) + "\r\n";
                        break;
                    default:
                        break;
                }
            }
            finally
            {
                // Move text box scroll
                textBox1.SelectionStart = textBox1.Text.Length;
                textBox1.Focus();
                textBox1.ScrollToCaret();
                textBox1.Refresh();
            }
        }

        // Printer Device Close
        private void button_PDeviceClose_Click(object sender, EventArgs e)
        {
            int r = 0;
            try
            {                
                // Device Close
                m_PosPrinter.DeviceEnabled = false;
                textBox1.Text += "PP : DeviceEnable(false) = Success\r\n";
                button_Receipt.Enabled = false;
                button_RotatePrint.Enabled = false;
                r++;
                m_PosPrinter.Release();
                textBox1.Text += "PP : Release = Success\r\n";
                r++;
                m_PosPrinter.Close();
                textBox1.Text += "PP : Close = Success\r\n";

                // Release Event Handler
                ReleasePrinterEvents();

                m_PosPrinter = null;

                button_PDeviceClose.Enabled = false;

            }
            catch (PosControlException ex)
            {
                // Throw
                switch (r)
                {
                    case 0:
                        textBox1.Text += "PP : DeviceEnable(false) = " + CheckErrorCode(ex) + "\r\n";
                        break;
                    case 1:
                        textBox1.Text += "PP : Release = " + CheckErrorCode(ex) + "\r\n";
                        break;
                    case 2:
                        textBox1.Text += "PP : Close = " + CheckErrorCode(ex) + "\r\n";
                        break;
                    default:
                        break;
                }
            }
            finally
            {
                // Move text box scroll
                textBox1.SelectionStart = textBox1.Text.Length;
                textBox1.Focus();
                textBox1.ScrollToCaret();
                textBox1.Refresh();
            }
        }

        // Registering an Event Handler 
        private void SetupPrinterEvents()
        {
            // StatusUpdateEvent
            m_PosPrinter.StatusUpdateEvent += new StatusUpdateEventHandler(OnStatusUpdateEventPP);
        }

        // Release Event Handler
        private void ReleasePrinterEvents()
        {
            m_PosPrinter.StatusUpdateEvent -= OnStatusUpdateEventPP;
        }

        // PP : StatusUpdateEvent
        private void OnStatusUpdateEventPP(object sender, StatusUpdateEventArgs e)
        {
            switch (e.Status)
            {
                case 11:
                    textBox1.Text += "PP : StatusUpdateEvent = CoverOpen(11)\r\n";
                    break;
                case 12:
                    textBox1.Text += "PP : StatusUpdateEvent = CoverOK(12)\r\n";
                    break;
                case 24:
                    textBox1.Text += "PP : StatusUpdateEvent = RecEmpty(24)\r\n";
                    break;
                case 25:
                    textBox1.Text += "PP : StatusUpdateEvent = RecNearempty(25)\r\n";
                    break;
                case 26:
                    textBox1.Text += "PP : StatusUpdateEvent = RecPaperok(26)\r\n";
                    break;
                case 62:
                    textBox1.Text += "PP : StatusUpdateEvent = RecCoverOpen(62)\r\n";
                    break;
                case 63:
                    textBox1.Text += "PP : StatusUpdateEvent = RecCoverOK(63)\r\n";
                    break;
                case 1001:
                    textBox1.Text += "PP : StatusUpdateEvent = Idle(1001)\r\n";
                    break;
                case 2001:
                    textBox1.Text += "PP : StatusUpdateEvent = PowerOnline(2001)\r\n";
                    break;
                case 2004:
                    textBox1.Text += "PP : StatusUpdateEvent = PowerOffOffline(2004)\r\n";
                    break;
                default:
                    break;
            }

            // Move text box scroll
            textBox1.SelectionStart = textBox1.Text.Length;
            textBox1.Focus();
            textBox1.ScrollToCaret();
            textBox1.Refresh();
        }

        // Drawer Device Open
        private void button_DDeviceOpen_Click(object sender, EventArgs e)
        {
            int r = 0;

            try
            {
                if (m_CashDrawer == null)
                {
                    // Generates a PosExplorer.
                    posExplorerDr = new PosExplorer(this);
                    DeviceInfo deviceInfo = null;

                    // Retrieve device information by device category and logical device name.
                    m_strLogicalNameDr = comboBox_Dr.SelectedItem.ToString();
                    deviceInfo = posExplorerDr.GetDevice(DeviceType.CashDrawer, m_strLogicalNameDr);
                    m_CashDrawer = (CashDrawer)posExplorerDr.CreateInstance(deviceInfo);

                    // Registering an Event Handler
                    SetupDrawerEvents();
                }

                button_DDeviceClose.Enabled = true;

                // DeviceOpen
                m_CashDrawer.Open();
                textBox1.Text += "CD : Open = Success\r\n";
                r++;
                m_CashDrawer.Claim(1000);
                textBox1.Text += "CD : Claim(1000) = Success\r\n";
                r++;
                m_CashDrawer.DeviceEnabled = true;
                textBox1.Text += "CD : DeviceEnabled(true) = Success\r\n";

                button_OpenDrawer.Enabled = true;

            }
            catch (PosControlException ex)
            {
                switch (r)
                {
                    case 0:
                        textBox1.Text += "CD : Open = " + CheckErrorCode(ex) + "\r\n";
                        break;
                    case 1:
                        textBox1.Text += "CD : Claim(1000) = " + CheckErrorCode(ex) + "\r\n";
                        break;
                    case 2:
                        textBox1.Text += "CD : DeviceEnabled(true) = " + CheckErrorCode(ex) + "\r\n";
                        break;
                    default:
                        break;
                }
            }
            finally
            {
                // Move text box scroll
                textBox1.SelectionStart = textBox1.Text.Length;
                textBox1.Focus();
                textBox1.ScrollToCaret();
                textBox1.Refresh();
            }
        }

        // Drawer Device Close
        private void button_DDeviceClose_Click(object sender, EventArgs e)
        {
            int r = 0;
            try
            {
                // Device Close
                m_CashDrawer.DeviceEnabled = false;
                textBox1.Text += "CD : DeviceEnable(false) = Success\r\n";
                button_OpenDrawer.Enabled = false;
                r++;
                m_CashDrawer.Release();
                textBox1.Text += "CD : Release = Success\r\n";
                r++;
                m_CashDrawer.Close();
                textBox1.Text += "CD : Close = Success\r\n";

                // Release Event Handler
                ReleaseDrawerEvents();

                m_CashDrawer = null;
                
                button_DDeviceClose.Enabled = false;

            }
            catch (PosControlException ex)
            {
                switch (r)
                {
                    case 0:
                        textBox1.Text += "CD : DeviceEnable(false) = " + CheckErrorCode(ex) + "\r\n";
                        break;
                    case 1:
                        textBox1.Text += "CD : Release = " + CheckErrorCode(ex) + "\r\n";
                        break;
                    case 2:
                        textBox1.Text += "CD : Close = " + CheckErrorCode(ex) + "\r\n";
                        break;
                    default:
                        break;
                }
            }
            finally
            {
                // Move text box scroll
                textBox1.SelectionStart = textBox1.Text.Length;
                textBox1.Focus();
                textBox1.ScrollToCaret();
                textBox1.Refresh();
            }
        }

        // Registering an Event Handler
        private void SetupDrawerEvents()
        {
            m_CashDrawer.StatusUpdateEvent += new StatusUpdateEventHandler(OnStatusUpdateEventCD);
        }

        // Release Event Handler
        private void ReleaseDrawerEvents()
        {
            m_CashDrawer.StatusUpdateEvent -= OnStatusUpdateEventCD;
        }

        // CD : StatusUpdateEvent
        private void OnStatusUpdateEventCD(object sender, StatusUpdateEventArgs e)
        {
            switch (e.Status)
            {
                case 0:
                    textBox1.Text += "CD : StatusUpdateEvent = Drawerclosed(0)\r\n";
                    break;
                case 1:
                    textBox1.Text += "CD : StatusUpdateEvent = Draweropen(1)\r\n";
                    break;
                default:
                    break;
            }

            // Move text box scroll
            textBox1.SelectionStart = textBox1.Text.Length;
            textBox1.Focus();
            textBox1.ScrollToCaret();
            textBox1.Refresh();
        }

        // Check for an ErrorCode
        private string CheckErrorCode(PosControlException errorcode)
        {
            string errorst;

            // ErrorCode
            switch (errorcode.ErrorCode)
            {
                case ErrorCode.Closed:
                    errorst = "Closed(101)";
                    break;
                case ErrorCode.NotClaimed:
                    errorst = "NotClaimed(103)";
                    break;
                case ErrorCode.NoService:
                    errorst = "NoService(104)";
                    break;
                case ErrorCode.Disabled:
                    errorst = "Disabled(105)";
                    break;
                case ErrorCode.Illegal:
                    errorst = "Illegal(106)";
                    break;
                case ErrorCode.NoHardware:
                    errorst = "NoHardware(107)";
                    break;
                case ErrorCode.NoExist:
                    errorst = "NoExist(109)";
                    break;
                case ErrorCode.Failure:
                    errorst = "Failure(111)";
                    break;
                case ErrorCode.Timeout:
                    errorst = "Timeout(112)";
                    break;
                case ErrorCode.Busy:
                    errorst = "Busy(113)";
                    break;
                case ErrorCode.Extended:
                    
                    // ErrorCodeExtended
                    switch(errorcode.ErrorCodeExtended)
                    {
                        case 201:
                            errorst = "Extended(114):CoverOpen(201)";
                            break;
                        case 203:
                            errorst = "Extended(114):ReceiptEmpty(203)";
                            break;
                        case 206:
                            errorst = "Extended(114):TooBig(206)";
                            break;
                        case 207:
                            errorst = "Extended(114):BadFormat(207)";
                            break;
                        case 281:
                            errorst = "Extended(114):BadFile(281)";
                            break;
                        case 10001:
                            errorst = "Extended(114):Blackmark(10001)";
                            break;
                        case 10003:
                            errorst = "Extended(114):Fatal(10003)";
                            break;
                        case 10006:
                            errorst = "Extended(114):Overheat(10006)";
                            break;
                        case 10008:
                            errorst = "Extended(114):Cutterjam(10008)";
                            break;
                        default:
                            errorst = "Extended(114):Unknown(" + errorcode + ")";
                            break;
                    }
                    break;
                default:
                    errorst = "";
                    break;
            }

            return errorst;
        }

        enum goods
        {
            Apples,
            Eggs,
            Tea,
            Rise,
            Wine,
            Noodle,
            LunchBox,
            Solt,
            Stationery
        }

        // Receipt sample
        private void button_Receipt_Click(object sender, EventArgs e)
        {

            int cnt = 0;
            int valplus;
            string sum;
            double valall = 0;
            double tax;
            double total;
            string[] valarray;
            valarray = new string[9]{"0.82","1.94","1.00","3.43","3.61","0.98","4.92",
                                      "1.47","1.18"};

            DateTime DateNow = DateTime.Now;

            // Total Amount
            for (valplus = 0; valplus < valarray.Length; valplus++)
            {
                sum = valarray[valplus];
                double valparse = double.Parse(sum);
                valall = valall + valparse;
            }
            tax = Math.Ceiling((valall * 0.05) * 100) / 100;
            total = valall + tax;

            try
            {
                m_PosPrinter.AsyncMode = false;
                m_PosPrinter.CharacterSet = 998;
                m_PosPrinter.TransactionPrint(PrinterStation.Receipt, PrinterTransactionControl.Transaction);

                // Logo print
                m_PosPrinter.PrintBitmap(PrinterStation.Receipt, "logo.bmp", -11, -2);
                m_PosPrinter.PrintNormal(PrinterStation.Receipt, "\r\n");

                // Company name
                m_PosPrinter.PrintNormal(PrinterStation.Receipt, "\x1B|cA" + "\x1B|bCFujitsu Supermarket\r\n");
                m_PosPrinter.PrintNormal(PrinterStation.Receipt, "\x1B|cA" + "\x1B|bCTel : 987-654-321" + "\x1B|!bC\r\n");


                // Date
                m_PosPrinter.PrintNormal(PrinterStation.Receipt, "\x1B|cA" + DateNow.ToString() + "\r\n");
                m_PosPrinter.PrintNormal(PrinterStation.Receipt, "\r\n");

                // Item information
                foreach (string name in Enum.GetNames(typeof(goods)))
                {
                    m_PosPrinter.PrintNormal(PrinterStation.Receipt, "  " + name.PadRight(10) + "$".PadLeft(12) + valarray[cnt] + "   a unit price" + "\r\n");
                    m_PosPrinter.PrintNormal(PrinterStation.Receipt, "  " + "@1".PadLeft(18) + "$".PadLeft(4) + valarray[cnt] + "\r\n");
                    cnt = cnt + 1;
                }
                m_PosPrinter.PrintNormal(PrinterStation.Receipt, "\r\n");

                // Amount Information
                m_PosPrinter.PrintNormal(PrinterStation.Receipt, "Subtotal".PadLeft(20) + "$".PadLeft(4) + valall + "\r\n");
                m_PosPrinter.PrintNormal(PrinterStation.Receipt, "Tax".PadLeft(20) + "$".PadLeft(4) + " " + tax + "\r\n");
                m_PosPrinter.PrintNormal(PrinterStation.Receipt, "Total".PadLeft(20) + "$".PadLeft(4) + total + "\r\n");
                m_PosPrinter.PrintNormal(PrinterStation.Receipt, "Cash".PadLeft(20) + "$".PadLeft(4) + "50.00\r\n");
                m_PosPrinter.PrintNormal(PrinterStation.Receipt, "Change".PadLeft(20) + "$".PadLeft(4) + (50.0 - total) + "\r\n");

                m_PosPrinter.PrintNormal(PrinterStation.Receipt, "\r\n");

                // Barcode Print
                m_PosPrinter.PrintBarCode(PrinterStation.Receipt, "1234567890123456", BarCodeSymbology.Itf, 100, 300, PosPrinter.PrinterBarCodeCenter, BarCodeTextPosition.Below);
                
                // Feed & Cut
                m_PosPrinter.PrintNormal(PrinterStation.Receipt, "\x1B|fP");

                m_PosPrinter.TransactionPrint(PrinterStation.Receipt, PrinterTransactionControl.Normal);

                textBox1.Text += "PP : Receipt Print = Success\r\n";
            }
            catch (PosControlException ex)
            {
                textBox1.Text += "PP : Receipt Print = Fail("+ CheckErrorCode(ex) +")\r\n";
            }
            finally
            {
                // Move text box scroll
                textBox1.SelectionStart = textBox1.Text.Length;
                textBox1.Focus();
                textBox1.ScrollToCaret();
                textBox1.Refresh();
            }
        }

        // Coupon print sample
        private void button_RotatePrint_Click(object sender, EventArgs e)
        {
            
            DateTime DateNow = DateTime.Now;
            
            try
            {
                m_PosPrinter.AsyncMode = false;
                m_PosPrinter.CharacterSet = 998;

                // Specify 90 degree rotation to the right
                m_PosPrinter.RotatePrint(PrinterStation.Receipt, PrintRotation.Right90 | PrintRotation.Barcode);


                m_PosPrinter.PrintNormal(PrinterStation.Receipt, "No. 1234567890".PadLeft(55) + "\n\n");

                // Coupon
                m_PosPrinter.PrintNormal(PrinterStation.Receipt, "--------------------------------------------------------\r\n");
                m_PosPrinter.PrintNormal(PrinterStation.Receipt, "\n\n");

                m_PosPrinter.PrintNormal(PrinterStation.Receipt, "\x1B|2vC\x1B|2hC  Take  \x1B|4vC\x1B|4hC\x1B|4hC$3 OFF !!\n");
                m_PosPrinter.PrintNormal(PrinterStation.Receipt, "--------------------------------------------------------\n");
                
                
                m_PosPrinter.PrintNormal(PrinterStation.Receipt, "\x1B|vC\x1B|hC    Save 3 dollars on Regular coffee at FIT Caffe.\n\n");
                m_PosPrinter.PrintNormal(PrinterStation.Receipt, "Issue date : ".PadLeft(40) + DateNow.ToString("d") + "\n\n");

                // Barcode print
                m_PosPrinter.PrintBarCode(PrinterStation.Receipt, "1234567890123456789", BarCodeSymbology.Itf, 100, 400, -3, BarCodeTextPosition.Below);

                // Cancel rotation designation
                m_PosPrinter.RotatePrint(PrinterStation.Receipt, PrintRotation.Normal);

                // Feed & Cut
                m_PosPrinter.PrintNormal(PrinterStation.Receipt, "\x1B|fP");

                textBox1.Text += "PP : Rotate Print = Success\r\n";
            }
            catch (PosControlException ex)
            {
                textBox1.Text += "PP : Rotate Print = Fail(" + CheckErrorCode(ex) + ")\r\n";
            }
            finally
            {
                // Move text box scroll
                textBox1.SelectionStart = textBox1.Text.Length;
                textBox1.Focus();
                textBox1.ScrollToCaret();
                textBox1.Refresh();
            }
        }

        // Drawer Open
        private void button_OpenDrawer_Click(object sender, EventArgs e)
        {
            try
            {
                m_CashDrawer.OpenDrawer();
                textBox1.Text += "CD : Open Drawer = Success\r\n";
            }
            catch(PosControlException ex)
            {
                textBox1.Text += "CD : Open Drawer = Fail(" + CheckErrorCode(ex) + ")\r\n";
            }
            finally
            {
                // Move text box scroll
                textBox1.SelectionStart = textBox1.Text.Length;
                textBox1.Focus();
                textBox1.ScrollToCaret();
                textBox1.Refresh();
            }
        }

    }
}
